# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

from ..core.datetime_utils import serialize_datetime
from ..core.pydantic_utilities import deep_union_pydantic_dicts, pydantic_v1
from ..core.unchecked_base_model import UncheckedBaseModel
from .evaluator_activation_deactivation_request_evaluators_to_activate_item import (
    EvaluatorActivationDeactivationRequestEvaluatorsToActivateItem,
)
from .evaluator_activation_deactivation_request_evaluators_to_deactivate_item import (
    EvaluatorActivationDeactivationRequestEvaluatorsToDeactivateItem,
)


class EvaluatorActivationDeactivationRequest(UncheckedBaseModel):
    evaluators_to_activate: typing.Optional[
        typing.List[EvaluatorActivationDeactivationRequestEvaluatorsToActivateItem]
    ] = pydantic_v1.Field(default=None)
    """
    Monitoring Evaluators to activate. These will be automatically run on new Logs.
    """

    evaluators_to_deactivate: typing.Optional[
        typing.List[EvaluatorActivationDeactivationRequestEvaluatorsToDeactivateItem]
    ] = pydantic_v1.Field(default=None)
    """
    Evaluators to deactivate. These will not be run on new Logs.
    """

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults_exclude_unset: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        kwargs_with_defaults_exclude_none: typing.Any = {"by_alias": True, "exclude_none": True, **kwargs}

        return deep_union_pydantic_dicts(
            super().dict(**kwargs_with_defaults_exclude_unset), super().dict(**kwargs_with_defaults_exclude_none)
        )

    class Config:
        frozen = True
        smart_union = True
        extra = pydantic_v1.Extra.allow
        json_encoders = {dt.datetime: serialize_datetime}
