# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

from ..core.datetime_utils import serialize_datetime
from ..core.pydantic_utilities import deep_union_pydantic_dicts, pydantic_v1
from ..core.unchecked_base_model import UncheckedBaseModel
from .categorical_feedback_label import CategoricalFeedbackLabel
from .feedback_type_model_type import FeedbackTypeModelType


class FeedbackTypeModel(UncheckedBaseModel):
    type: FeedbackTypeModelType = pydantic_v1.Field()
    """
    The type of feedback. The default feedback types available are 'rating', 'action', 'issue', 'correction', and 'comment'.
    """

    values: typing.Optional[typing.List[CategoricalFeedbackLabel]] = pydantic_v1.Field(default=None)
    """
    The allowed values for categorical feedback types. Not populated for `correction` and `comment`.
    """

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults_exclude_unset: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        kwargs_with_defaults_exclude_none: typing.Any = {"by_alias": True, "exclude_none": True, **kwargs}

        return deep_union_pydantic_dicts(
            super().dict(**kwargs_with_defaults_exclude_unset), super().dict(**kwargs_with_defaults_exclude_none)
        )

    class Config:
        frozen = True
        smart_union = True
        extra = pydantic_v1.Extra.allow
        json_encoders = {dt.datetime: serialize_datetime}
